
#*********************************************************************
#
# Copyright 2016 Broadcom.
#
#  Licensed under the Apache License, Version 2.0 (the "License")
#  you may not use this file except in compliance with the License.
#  You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
#  Unless required by applicable law or agreed to in writing, software
#  distributed under the License is distributed on an "AS IS" BASIS,
#  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#  See the License for the specific language governing permissions and
#  limitations under the License.
#
#***********************************************************************

class Tenant():
    '''
    Class that abstracts a tenant.
    '''

    def __init__(self):
        self._name = None 
        self._password = None
        self._id = None
        self._vlan = None
        self._hypervisors = None
        self._servers = None
        self._servers_on_hypervisor = {}
        self._devices = set()
        self._networks = None
        self._dirty = False

    def set_dirty(self, dirty):
        self._dirty = dirty

    def is_dirty(self):
        return self._dirty

    def set_name(self, name):
        self._name = name

    def get_name(self):
        return self._name

    def set_password(self, password):
        self._password = password

    def get_password(self):
        return self._password

    def set_vlan(self, vlan):
        self._vlan = vlan

    def get_vlan(self):
        return self._vlan

    def set_id(self, id):
        self._id = id

    def get_id(self):
        return self._id

    def set_hypervisors(self, hypervisors):
        self._hypervisors = hypervisors

    def get_hypervisors(self):
        return self._hypervisors
        
    def set_networks(self, networks):
        self._networks = networks

    def get_networks(self):
        return self._networks
        
    def set_servers(self, servers):
        self._servers = servers

    def get_servers(self):
        return self._servers

    def set_servers_on_hypervisor(self, name, servers):
        self._servers_on_hypervisor[name] = servers

    def get_servers_on_hypervisor(self, name):
        return self._servers_on_hypervisor[name]

    def hyper_has_server_in_net(self, hyper, netname):
        ret = False
        servers = self.get_servers_on_hypervisor(hyper["name"])
        for x in servers:
            addrs = x.addresses
            try:
                tmp = addrs[netname]
                ret = True
                break
            except:
                pass
        return ret
            
